;======================================= 
;--------------------------------------- 
; 
;   Name file: Shadow_Include
; 
;   Programmatore: 
;      Caldarulo Vincenzo (Eye & Light) 
;   Descrizione: 
;			Creazione dei volumi d'ombra
; 
;--------------------------------------- 
;======================================= 
Include"commontype.bb"
;======================================= 
;--------------------------------------- 
; Variabili ShadowVolume 
;--------------------------------------- 
;======================================= 
; Ps: azzerare sempre prima di creare una nuova luce 
sh_level# = 0.2
Global Scena = CreatePivot(); CreateSphere(5)
Global MeshFront = CreateMesh(); 
Global SurfaceFront = CreateSurface(MeshFront); 
EntityAlpha MeshFront, sh_level 
EntityColor MeshFront, 255,0,0 
EntityFX MeshFront,1;4
EntityBlend MeshFront,3

Dim EdgeFront.EdgeF(65000)
For a=0 To 65000
	EdgeFront.EdgeF(a) = New EdgeF
	EdgeFront(a)\Point0.Point3D = New Point3D 
	EdgeFront(a)\Point1.Point3D = New Point3D 
	EdgeFront(a)\Ray0.Point3D = New Point3D 
	EdgeFront(a)\Ray1.Point3D = New Point3D 
Next

;Dim Triang(65000)
Global TmpMesh =CreateMesh()
Global TmpSurf =CreateSurface(TmpMesh)
EntityFX TmpMesh,1+2
Global cntLine3D=0
Dim Line3DAX#(65000)
Dim Line3DAY#(65000)
Dim Line3DAZ#(65000)
Dim Line3DBX#(65000)
Dim Line3DBY#(65000)
Dim Line3DBZ#(65000)
;===>
;Creiamo il piano che proietter l'ombra
;===>
Const SHWTexSize = 256; Parametro di regolazione Ombra
;===>
Dim BG1(SHWTexSize,SHWTexSize)
Dim BG2(SHWTexSize,SHWTexSize)
;===>
Global SHWSpriteFront=CreateSprite()
Global ShwTex1=CreateTexture(SHWTexSize,SHWTexSize,1+2+8+256+512)
EntityTexture SHWSpriteFront,ShwTex1
EntityFX SHWSpriteFront,1
EntityParent SHWSpriteFront,Camera
;===>
;se cancello questo esce un bel MAV
Global ShwTex2=CreateTexture(SHWTexSize,SHWTexSize,1+2)
;===>
Global sh_v1.Point3D			= New Point3D 
Global sh_v2.Point3D			= New Point3D 
Global sh_v3.Point3D			= New Point3D 
Global sh_light.Point3D		= New Point3D 
Global sh_lenght.Point3D	= New Point3D 
;======================================= 
;--------------------------------------- 
; Memoria Vertici Shadow 
;--------------------------------------- 
;======================================= 
Type EdgeF
	Field Surf	
	Field Triangle
	Field Point0.Point3D
	Field Point1.Point3D
	Field Ray0.Point3D
	Field Ray1.Point3D
End Type







;======================================================================= 
;======================================================================= 
; Shadow Volume For silhouette Standard Method
;======================================================================= 
;======================================================================= 
;======================= 
Function ResetShadowVolume() 
   ClearSurface SurfaceFront; 
End Function 
;======================= 
; Shadows Volume start 
Function ShadowVolume$( model, Scale, Light, LightLenght, Normalize=False)
	ResetShadowVolume()
	;===>
	sh_light\x = EntityX(Light) : sh_light\y = EntityY(Light) : sh_light\z = EntityZ(Light) 
	sh_lenght\x = LightLenght 
	sh_lenght\y = LightLenght 
	sh_lenght\z = LightLenght 
	;===>
	result$=ShadowVolumeCreate3( model, Normalize)
	;===>
	ShadowVolumeCreateImage()
	;===>
	Return result$
	;===>
End Function 
;=======================
; Creazione immagine ombra
; ottimizzazione completata 
Function ShadowVolumeCreateImage()
	;===>
	; Fase 1
	;===>
	Local CaptureX = TextureWidth(ShwTex1)
	Local CaptureY = TextureHeight(ShwTex1)
	CameraViewport Camera,0,0,CaptureX, CaptureY
	;===>
	HideEntity SHWSpriteFront 
	;===>
	HideEntity MeshFront 
	ShowEntity Scena
	RenderWorld
	CameraClsMode camera,True,False
	;===>
	HideEntity Scena
	;per ottimizzare renderizzo prima il back
	ShowEntity MeshFront
	FlipMesh MeshFront ;Visualizzo il back face
	;preparo in back face
	EntityColor MeshFront,10,10,10
	RenderWorld
	;===>
	; Front Ground 1
	LockBuffer()
	For y=0 To 	CaptureY
		For x=0 To 	CaptureX
			;===>
			bg2(x,y)=ReadPixelFast(x,y)
			;===>
		Next
	Next
	UnlockBuffer()
	;proparo in front face
	FlipMesh MeshFront
	RenderWorld
	;===>
	; Back Ground 2
	LockBuffer()
	For y=0 To 	CaptureY
		For x=0 To 	CaptureX
			;===>
			bg1(x,y)=ReadPixelFast(x,y)
			;===>
		Next
	Next
	UnlockBuffer()
	;===>
	HideEntity MeshFront
	;===>
	;Ripristiniamo tutto prima di riprendere le normali attivit
	;===>
	; Filter
	SetBuffer TextureBuffer(ShwTex1)
	LockBuffer()
	ShadowColor=(128 Shl 24)
	For y=0 To 	CaptureY
		For x=0 To 	CaptureX
			;===>
			Val=(Bg1(x,y)-Bg2(x,y))
			;Val=Abs(Bg1(x,y)-Bg2(x,y))
			If (Val)>0 Then
				WritePixelFast x,y,ShadowColor
			Else
				WritePixelFast x,y,0
			EndIf
			;===>
		Next
	Next
	UnlockBuffer()
	;===>
	CameraViewport Camera,0,0,GraphicsWidth(), GraphicsHeight()
	CameraClsMode camera,True,True
	;===>
	ShowEntity SHWSpriteFront 
	ShowEntity Scena
	;===>
	SetBuffer BackBuffer()
	Cls

	PositionEntity SHWSpriteFront,EntityX(Camera),EntityY(Camera),EntityZ(Camera)+1.001
	;===>
End Function 
;=======================
; Shadows Volume Create 
; !!! da ottimizzare !!!
Function CheckVertex%(a.Point3D,b.Point3D)
	If (a\x=b\x)And(a\y=b\y)And(a\z=b\z) Then
		Return True 
	Else
		Return False 
	EndIf 
End Function 
;=======================
; Creazione volume
; forse si pu fare ancora qualcosina!!
Function ShadowVolumeCreate3$( model, Normalize)
	;===> 
	Local Result$=""
	Local Norm.Point3D=New Point3D 
	Local MidPoint.Point3D=New Point3D 
	Local NormLight.Point3D=New Point3D
	Local CNTFront=0
	Local CNTBack=0
	Local surf=0
	Local check1 = False
	Local check2 = False

	t0=MilliSecs()
	;===> 
	; Cerchiamoci i vertici faccia vista verso la luce
	For n=1 To CountSurfaces(model) 
		surf = GetSurface(model,n) 
		dwNumFaces = CountTriangles(surf)-1 
		For v=0 To dwNumFaces
			;Stop
			;===> 
			vert0 = TriangleVertex(surf,v,0) : vert1 = TriangleVertex(surf,v,1) : vert2 = TriangleVertex(surf,v,2)
			;===>
			;associamo le trasformazioni ai vertici
			TFormPoint VertexX( surf, vert0), VertexY( surf, vert0) , VertexZ( surf, vert0 ), model, 0
			sh_v1\x = TFormedX() : sh_v1\y = TFormedY() : sh_v1\z = TFormedZ()
			;===> 
			;associamo le trasformazioni ai vertici
			TFormPoint VertexX( surf, vert1), VertexY( surf, vert1) , VertexZ( surf, vert1 ), model, 0
			sh_v2\x = TFormedX() : sh_v2\y = TFormedY() : sh_v2\z = TFormedZ() 
			;===> 
			;associamo le trasformazioni ai vertici
			TFormPoint VertexX( surf, vert2), VertexY( surf, vert2) , VertexZ( surf, vert2 ), model, 0
			sh_v3\x = TFormedX() : sh_v3\y = TFormedY() : sh_v3\z = TFormedZ() 
			;===> 
			Norm= CalcNormal(sh_v1,sh_v2,sh_v3)
			MidPoint=V_3Mid(sh_v1,sh_v2,sh_v3) 
			NormLight= V_3Dec(MidPoint,sh_light) 
			Norm = V_3Normalize(Norm) 
			NormLight = V_3Normalize(NormLight) 
			Dot#=V_3Dot(Norm,NormLight) 
			;===>
			; Ricerchiamo i vertici rivolti verso la luce e non e li memoriziamo
			If Dot#=>0 And Dot#<=1 Then
				;Stop
				;VertexColor surf,vert0,255,0,0
				;VertexColor surf,vert1,255,0,0
				;VertexColor surf,vert2,255,0,0
				;===>
				; Edge 1
				;===>
				ID_EdgeF.EdgeF = edgeFront(CNTFront)
				ID_EdgeF\Surf = surf
				ID_EdgeF\Triangle = v
				V_3Copy(ID_EdgeF\Point0,sh_v1)
				V_3Copy(ID_EdgeF\Point1,sh_v2)
				CNTFront=CNTFront+1
				;===>
				; Edge 2
				;===>
				ID_EdgeF.EdgeF = edgeFront(CNTFront)
				ID_EdgeF\Surf = surf
				ID_EdgeF\Triangle = v
				V_3Copy(ID_EdgeF\Point0,sh_v2)
				V_3Copy(ID_EdgeF\Point1,sh_v3)
				CNTFront=CNTFront+1
				;===>
				; Edge 3Result$
				;===>
				ID_EdgeF.EdgeF = edgeFront(CNTFront)
				ID_EdgeF\Surf = surf
				ID_EdgeF\Triangle = v
				V_3Copy(ID_EdgeF\Point0,sh_v3)
				V_3Copy(ID_EdgeF\Point1,sh_v1)
				CNTFront=CNTFront+1
				;===>
			EndIf
			;===> 
		Next 
	Next
	t1=MilliSecs()
	t2=t1-t0
	Result$=Result$+" ==> Facce Front : "+CNTFront+"  Facce Back : "+CNTBack + " T-Vert: " + t2
	;===> 
	t0=MilliSecs()
	cntUguali=0
	cntDiverse=0
	;cntLine3D=0
	For a=0 To CNTFront
		;===> 
		If (EdgeFront(a)\surf>0) Then
			;===>
			Diverso=True
			MemB=0
			;===>
			; Inizializziamo i puntatori
			ID_EdgeFA.EdgeF = edgeFront(a) ; funziona come i puntatori del c++
			ID_P0.Point3d = ID_EdgeFA\Point0
			ID_P1.Point3d = ID_EdgeFA\Point1	; Puntiamo a Point - funziona come i puntatori del c++
			;===>
			For b=a+1 To CNTFront	; Ottimizzazione 2
				;===>
				ID_EdgeFB.EdgeF = edgeFront(b)
				;===>
				If (ID_EdgeFB\surf>0) Then
					;===>
					; verifichiamo che i vertici che stiamo visionando non appartengano allo stesso triangolo
					;===>
					;Ulteriore verifica di diversit
					check1 = CheckVertex( ID_P0, ID_EdgeFB\Point0 )
					check2 = CheckVertex( ID_P1, ID_EdgeFB\Point1 )
						;===>
					If  (check1 And check2)  Then
						;===>
						MemB=b
						;===>
						cntUguali = cntUguali + 1
						ID_EdgeFA\surf = 0
						ID_EdgeFB\surf = 0
						Diverso = False
						Exit
						;===>
					Else
						;===>
						check1 = CheckVertex(ID_P0,ID_EdgeFB\Point1)
						check2 = CheckVertex(ID_P1,ID_EdgeFB\Point0)
						;===>
						If (check1 And check2) Then
							;===>
							MemB=b
							;===>
							cntUguali=cntUguali+1
							ID_EdgeFA\surf=0
							ID_EdgeFB\surf=0
							Diverso=False
							Exit
							;===>
						EndIf
						;===>
					EndIf
					;===>
				EndIf
				;===> 
			Next
			;===>
			If  (Diverso=True) Then
				cntDiverse=cntDiverse+1
				;===>
				; per debug
				;VertexColor EdgeFront(a)\surf,EdgeFront(a)\Vert0,255,0,255
				;VertexColor EdgeFront(a)\surf,EdgeFront(a)\Vert1,255,0,255
				;===>
				ID_EdgeFA\Ray0 = V_3Dec( ID_P0, sh_light ) 
				V_3Normalize(ID_EdgeFA\Ray0 ) 
				ID_EdgeFA\Ray0 = V_3Inc( V_3Mul(ID_EdgeFA\Ray0, sh_lenght ), ID_P0 )
				;===>
				ID_EdgeFA\Ray1 = V_3Dec( ID_P1,sh_light ) 
				V_3Normalize( ID_EdgeFA\Ray1 ) 
				ID_EdgeFA\Ray1 = V_3Inc( V_3Mul( ID_EdgeFA\Ray1, sh_lenght ), ID_P1 ) 
				;===>
				va = AddVertex(SurfaceFront,  ID_P0\x, 					ID_P0\y, 					ID_P0\z ); 
				vb = AddVertex(SurfaceFront,  ID_EdgeFA\Ray0\x,	ID_EdgeFA\Ray0\y,	ID_EdgeFA\Ray0\z ); 
				vc = AddVertex(SurfaceFront,  ID_EdgeFA\Ray1\x,	ID_EdgeFA\Ray1\y,	ID_EdgeFA\Ray1\z); 
				vd = AddVertex(SurfaceFront,  ID_P1\x, 					ID_P1\y, 					ID_P1\z ); 
				;===>
				AddTriangle(SurfaceFront, va, vb, vc); faccia 1/3 a 
				AddTriangle(SurfaceFront, va, vc, vd); faccia 1/3 b
				;===>
				ID_EdgeFA\surf=0
				EdgeFront(MemB)\surf=0
				;===>
				Line3DAX(cntLine3D) = ID_P0\x : Line3DAY(cntLine3D) = ID_P0\y : Line3DAZ(cntLine3D) = ID_P0\z
				Line3DBX(cntLine3D) = ID_P1\x : Line3DBY(cntLine3D) = ID_P1\y : Line3DBZ(cntLine3D) = ID_P1\z
				cntLine3D=cntLine3D+1
				;===>
			EndIf
		;===>
		EndIf
		;===>
	Next
	t1=MilliSecs()
	t2=t1-t0
	Result$=Result$+" Edges : "+cntDiverse+"  T-silhouette: " + T2
	;===>
	.jump
	;UpdateNormals model
;	For e=1 To CountChildren(Model) 
;		limb = GetChild(model,e) 
;		ShadowVolumeCreate3(limb, Normalize) 
;	Next 
	;===>
	;Stop
	Delete Norm.Point3D
	Delete MidPoint.Point3D
	Delete NormLight.Point3D
	;===>
	Return Result$
End Function 
;=======================
;
Function SHWLine3D()
	;===>
	Color 255,0,0
	;===>
	For a=0 To cntLine3D-1
		Line3D( Line3DAX(a), Line3DAY(a), Line3DAZ(a), Line3DBX(a), Line3DBY(a), Line3DBZ(a))
	Next
	cntLine3D=0
	;===>
	Color 255,255,255
	;===>
End Function


;======================================================================= 
;======================================================================= 
; Shadow Volume For silhouette Method Edge to Edge
;======================================================================= 
;======================================================================= 
;======================= 







