;======================================= 
;--------------------------------------- 
; 
;   Name file: Shadow_Include
; 
;   Programmatore: 
;      Caldarulo Vincenzo (Eye & Light) 
;   Descrizione: 
;			Creazione dei volumi d'ombra
; 
;--------------------------------------- 
;======================================= 
Include"commontype.bb"
;======================================= 
;--------------------------------------- 
; Variabili ShadowVolume 
;--------------------------------------- 
;=======================================

Const D3DCULL_CW = 2
Const D3DCULL_CCW = 3
Const D3DSTENCILOP_KEEP = 1
Const D3DSTENCILOP_INCR = 7
Const D3DSTENCILOP_DECR = 8
Const D3DCMP_LESSEQUAL = 4
Const D3DCMP_ALWAYS = 8
Const D3DBLEND_ZERO = 1
Const D3DBLEND_ONE = 2
Const D3DBLEND_SRCALPHA = 5
Const D3DBLEND_INVSRCALPHA = 6
Const D3DBLEND_INVDESTALPHA = 8
Const D3DRS_ZENABLE = 7
Const D3DRS_ZWRITEENABLE = 14
Const D3DRS_SRCBLEND = 19
Const D3DRS_DESTBLEND = 20
Const D3DRS_CULLMODE = 22
Const D3DRS_ALPHABLENDENABLE = 27
Const D3DRS_STENCILENABLE = 52
Const D3DRS_STENCILFAIL = 53
Const D3DRS_STENCILZFAIL = 54
Const D3DRS_STENCILPASS = 55
Const D3DRS_STENCILFUNC = 56
Const D3DRS_STENCILREF = 57
Const D3DRS_STENCILMASK = 58
Const D3DRS_STENCILWRITEMASK = 59
Global Direct3DDevice7

;===>
Type EdgeToEdge
	Field IdModel
	Field cntSurface
	Field Surfaces.ETE_Surface
End Type
;===>
Type ETE_Surface
	Field IdSurface
	Field cntTriangle
	Field IdTriangle.ETE_Triangle[ETE_MaxTriang]
End Type
;===>
Type ETE_Triangle
	Field Normal.Point3D
	Field a.Point3D
	Field b.Point3D
	Field c.Point3D
	Field Triangle
	Field ATriangle
	Field BTriangle
	Field CTriangle
End Type
;===>
Type ETE_Light
	Field IdLight
	Field R%
	Field G%
	Field B%
	Field Intensity
End Type
;===>

;======================================= 
;===>
Const SHWTexSize = 128; Parametro di regolazione Ombra
Const sh_level# = 0.1
Const ETE_MaxTriang=65000
Const SHWL3D = 65000
Const FactLight=1
;===>
;======================================= 
;===>
Dim TriangleClone.ETE_Triangle(ETE_MaxTriang)
Dim AD(65000,2)
;===>
;======================================= 
;===>
Global Scena = CreatePivot(); CreateSphere(5)
;===>
Global MeshFront = CreateMesh(); 
Global SurfaceFront = CreateSurface(MeshFront); 
EntityAlpha MeshFront, sh_level 
EntityFX MeshFront,1;4
EntityBlend MeshFront,3
;===>
Global cntLine3D=0
Dim Line3DAX#(SHWL3D)
Dim Line3DAY#(SHWL3D)
Dim Line3DAZ#(SHWL3D)
Dim Line3DBX#(SHWL3D)
Dim Line3DBY#(SHWL3D)
Dim Line3DBZ#(SHWL3D)
;===>
;Creiamo il piano che proietter l'ombra
;===>
Global SHWScreenImage = CreateImage(SHWTexSize,SHWTexSize)
Global SHWSpriteFront=CreateSprite()
SpriteViewMode SHWSpriteFront,1
;Global ShwTex1=CreateTexture(SHWTexSize,SHWTexSize,1+2+8+512)
;EntityTexture SHWSpriteFront,ShwTex1
EntityFX SHWSpriteFront,1
;===>
Global sh_light.Point3D		= New Point3D 
Global sh_lenght.Point3D	= New Point3D 
;===>
Global SHW_ETE_Object.EdgeToEdge
;===>
;======================================= 
;===>
;=======================
; 
Function CheckVertex%(a.Point3D,b.Point3D)
	If (a\x=b\x)And(a\y=b\y)And(a\z=b\z) Then
		Return True 
	Else
		Return False 
	EndIf 
End Function 
;======================================================================= 
;======================================================================= 
; Shadow Volume For silhouette Method Edge to Edge
;======================================================================= 
;======================================================================= 
;======================= 
; Inizialize Object Shadow
Function SHW_Init()
	Direct3DDevice7 = SystemProperty$("Direct3DDevice7")
	;===>
	; Search surface and triangle object
	For n=0 To ETE_MaxTriang
	
		TriangleClone.ETE_Triangle(n) = New ETE_Triangle
		
		TriangleClone(n)\Normal.Point3D = New Point3D
		TriangleClone(n)\a.Point3D = New Point3D
		TriangleClone(n)\b.Point3D = New Point3D
		TriangleClone(n)\c.Point3D = New Point3D
	Next
	ShwInitDisplay()

End Function 
;======================= 
;
Function ShwInitDisplay()
	;===>
	EntityParent(SHWSpriteFront,Camera) 
	PositionEntity SHWSpriteFront,-0.005,+0.005,1.001 
	;===>
End Function 
;=======================
; Inizialize Object Shadow
Function SHW_InitObject$(model)
	Time$=""
	Tim1=MilliSecs()
	Norm.Point3D = New Point3D
	
	SHW_ETE_Object.EdgeToEdge = New EdgeToEdge
	SHW_ETE_Object\IdModel = model
	;===>
	; Search surface and triangle object
	SHW_ETE_Object\cntSurface = CountSurfaces(model)-1
	For n=0 To SHW_ETE_Object\cntSurface
		;===>
		surf = GetSurface(model,n+1)
		NumFaces = CountTriangles(surf)-1
		;===>
		SHW_ETE_Object\Surfaces.ETE_Surface = New  ETE_Surface
		IdSurface.ETE_Surface = SHW_ETE_Object\Surfaces
		;===>
		IdSurface\IdSurface = surf
		IdSurface\cntTriangle = NumFaces
		For v=0 To NumFaces
			;===>
			IdSurface\IdTriangle.ETE_Triangle[v] = New ETE_Triangle
			IdTriang.ETE_Triangle = IdSurface\IdTriangle[v]
			;===>
			IdTriang\normal.Point3D = New Point3D
			IdTriang\a.Point3D = New Point3D
			IdTriang\b.Point3D = New Point3D
			IdTriang\c.Point3D = New Point3D
			;===> 
			vert0 = TriangleVertex(surf,v,0)
			vert1 = TriangleVertex(surf,v,1)
			vert2 = TriangleVertex(surf,v,2)
			;===>
			IdTriang\a\x = VertexX( surf, vert0) : IdTriang\a\y = VertexY( surf, vert0) : IdTriang\a\z = VertexZ( surf, vert0)
			;===> 
			IdTriang\b\x = VertexX( surf, vert1) : IdTriang\b\y = VertexY( surf, vert1) : IdTriang\b\z = VertexZ( surf, vert1)
			;===> 
			IdTriang\c\x = VertexX( surf, vert2) : IdTriang\c\y = VertexY( surf, vert2) : IdTriang\c\z = VertexZ( surf, vert2)
			;===>
			CalcNormal( IdTriang\Normal, IdTriang\a, IdTriang\b, IdTriang\c)
			V_3Normalize( IdTriang\Normal, IdTriang\Normal) 
			;===>
			IdTriang\Triangle = v
			IdTriang\ATriangle = -1
			IdTriang\BTriangle = -1
			IdTriang\CTriangle = -1
			;===>
		Next 
		;===>
		; Search adjacent triangle
		;===>
		; ottimizzazione precalcolo
		For a=0 To IdSurface\cntTriangle
			AD(a,0)=1 : AD(a,1) = 1 : AD(a,2) = 1
		Next
		;===>
		For a=0 To IdSurface\cntTriangle
			;===>
			ATriang.ETE_Triangle = IdSurface\IdTriangle[a]
			;===>
			For b=a+1 To IdSurface\cntTriangle
				;===>
				state1=AD(b,0) : state2=AD(b,1) : state3=AD(b,2)
				If a=b Or ( state1=0 And state2=0 And state3=0 ) Then Goto SIDEC
				;===>
				BTriang.ETE_Triangle = IdSurface\IdTriangle[b]
				;*********************************************************************
				; SIDE " A "
				;===>
				; Adjacent side A (il lato A del 1 triangolo confina con lato A del 2 Triangolo)
				If (state1=1)Then
					;===>
					check1 = CheckVertex( ATriang\a, BTriang\a )
					check2 = CheckVertex( ATriang\b, BTriang\b )
					check3 = CheckVertex( ATriang\a, BTriang\b )
					check4 = CheckVertex( ATriang\b, BTriang\a )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\ATriangle = b
						BTriang\ATriangle = a
						AD(b,0)=0
						Goto SIDEA
						;Stop
					EndIf
					;===>
				EndIf
				;===>
				; Adjacent side A (il lato A del 1 triangolo confina con lato B del 2 Triangolo)
				If (state2=1)Then
					;===>
					check1 = CheckVertex( ATriang\a, BTriang\b )
					check2 = CheckVertex( ATriang\b, BTriang\c )
					check3 = CheckVertex( ATriang\a, BTriang\c )
					check4 = CheckVertex( ATriang\b, BTriang\b )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\ATriangle = b
						BTriang\BTriangle = a
						AD(b,1)=0
						Goto SIDEA
						;Stop
					EndIf
					;===>
				EndIf
				;===>
				; Adjacent side A (il lato A del 1 triangolo confina con lato C del 2 Triangolo)
				If (state3=1)Then
					;===>
					check1 = CheckVertex( ATriang\a, BTriang\c )
					check2 = CheckVertex( ATriang\b, BTriang\a )
					check3 = CheckVertex( ATriang\a, BTriang\a )
					check4 = CheckVertex( ATriang\b, BTriang\c )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\ATriangle = b
						BTriang\CTriangle = a
						AD(b,2)=0
						;Stop
					EndIf
					;===>
				EndIf
				.SIDEA
				;===>
				;*********************************************************************
				; SIDE " B "
				;===>
				; Adjacent side A (il lato B del 1 triangolo confina con lato A del 2 Triangolo)
				If (state1=1)Then
					;===>
					check1 = CheckVertex( ATriang\b, BTriang\a )
					check2 = CheckVertex( ATriang\c, BTriang\b )
					check3 = CheckVertex( ATriang\b, BTriang\b )
					check4 = CheckVertex( ATriang\c, BTriang\a )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\BTriangle = b
						BTriang\ATriangle = a
						AD(b,0)=0
						Goto SIDEB
						;Stop
					EndIf 
					;===>
				EndIf 
				;===>
				; Adjacent side A (il lato B del 1 triangolo confina con lato B del 2 Triangolo)
				If (state2=1)Then
					;===>
					check1 = CheckVertex( ATriang\b, BTriang\b )
					check2 = CheckVertex( ATriang\c, BTriang\c )
					check3 = CheckVertex( ATriang\b, BTriang\c )
					check4 = CheckVertex( ATriang\c, BTriang\b )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\BTriangle = b
						BTriang\BTriangle = a
						AD(b,1)=0
						Goto SIDEB
						;Stop
					EndIf
					;===>
				EndIf
				;===>
				; Adjacent side A (il lato B del 1 triangolo confina con lato C del 2 Triangolo)
				If (state3=1)Then
					;===>
					check1 = CheckVertex( ATriang\b, BTriang\c )
					check2 = CheckVertex( ATriang\c, BTriang\a )
					check3 = CheckVertex( ATriang\b, BTriang\a )
					check4 = CheckVertex( ATriang\c, BTriang\c )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\BTriangle = b
						BTriang\CTriangle = a
						AD(b,2)=0
						;Stop
					EndIf
					;===>
				EndIf
				.SIDEB
			;===>
				;*********************************************************************
				; SIDE " C "
				;===>
				; Adjacent side A (il lato C del 1 triangolo confina con lato A del 2 Triangolo)
				If (state1=1)Then
					;===>
					check1 = CheckVertex( ATriang\c, BTriang\a )
					check2 = CheckVertex( ATriang\a, BTriang\b )
					check3 = CheckVertex( ATriang\c, BTriang\b )
					check4 = CheckVertex( ATriang\a, BTriang\a )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\CTriangle = b
						BTriang\ATriangle = a
						AD(b,0)=0
						Goto SIDEC
						;Stop
					EndIf
				;===>
				EndIf
				;===>
				; Adjacent side A (il lato C del 1 triangolo confina con lato B del 2 Triangolo)
				If (state2=1)Then
					;===>
					check1 = CheckVertex( ATriang\c, BTriang\b )
					check2 = CheckVertex( ATriang\a, BTriang\c )
					check3 = CheckVertex( ATriang\c, BTriang\c )
					check4 = CheckVertex( ATriang\a, BTriang\b )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\CTriangle = b
						BTriang\BTriangle = a
						AD(b,1)=0
						Goto SIDEC
						;Stop
					EndIf
					;===>
				EndIf 
				;===>
				; Adjacent side A (il lato C del 1 triangolo confina con lato C del 2 Triangolo)
				If (state3=1)Then
					;===>
					check1 = CheckVertex( ATriang\c, BTriang\c )
					check2 = CheckVertex( ATriang\a, BTriang\a )
					check3 = CheckVertex( ATriang\c, BTriang\a )
					check4 = CheckVertex( ATriang\a, BTriang\c )
					;===>
					If  (check1 And check2) Or (check3 And check4) Then
						ATriang\CTriangle = b
						BTriang\CTriangle = a
						AD(b,2)=0
						;Stop
					EndIf
					;===>
				EndIf
				.SIDEC
				;===>
			Next
			;===>
		Next 
		;===>
	Next
	;===>
	Delete Norm
	;===>
	Tim2=MilliSecs()
	Time$="Time Precalcolo: "+(Tim2-Tim1)
	Return Time$
	;===>
End Function 
;=======================
; Inizialize Object Shadow
Function CloneListTriangle(dst.ETE_Triangle,src.ETE_Triangle)
	;===>
	V_3Copy( dst\Normal, src\Normal)
	V_3Copy( dst\a, src\a)
	V_3Copy( dst\b, src\b)
	V_3Copy( dst\c, src\c)
	dst\Triangle = src\Triangle
	dst\ATriangle = src\ATriangle
	dst\BTriangle = src\BTriangle
	dst\CTriangle = src\CTriangle
	;===>
End Function 
;=======================
Function ResetShadowVolume()
	ClearSurface SurfaceFront;
	SurfaceFront = CreateSurface(MeshFront); 

End Function 
;======================= 
; Shadows Volume start 
Function ShadowVolume$( Light, LightLenght, ShowVol=False, SBHardware=False )
	ResetShadowVolume()
	;===>
	sh_light\x = EntityX(Light) : sh_light\y = EntityY(Light) : sh_light\z = EntityZ(Light) 
	sh_lenght\x = LightLenght 
	sh_lenght\y = LightLenght 
	sh_lenght\z = LightLenght 
	;===>
	cntLine3D=0
	;===>
	UpdateWorld()
	;===>
	result$=ShadowVolumeCreate3()
	;===>
	result$=result$+ShadowVolumeSimulateStenciHardware1(ShowVol) ; gestione hardware
	;===>
	Return result$
	;===>
End Function 
;=======================
; Creazione volume
; forse si pu fare ancora qualcosina!!
Function ShadowVolumeCreate3$()
	;===> 
	t0=MilliSecs()
	;===> 
	Local Result$ = ""
	;===> 
	Local RayA.Point3D = New Point3D 
	Local RayB.Point3D = New Point3D 
	Local RayC.Point3D = New Point3D
	Local Norm.Point3D = New Point3D
	Local MidPoint.Point3D = New Point3D
	Local NormLight.Point3D = New Point3D
	;===> 
	Local IdA.Point3D
	Local IdB.Point3D
	Local IdC.Point3D
	Local IdN.Point3D
	Local IdTriang.ETE_Triangle
	Local IdCLT.ETE_Triangle
	Local Surfaces.ETE_Surface
	;===> 
	Local CNTFront=0
	Local CNTBack=0
	Local surf=0
	Local check1 = -1
	Local check2 = -1
	Local check3 = -1
	Local va=0
	Local vb=0
	Local vc=0
	Local vd=0
	;===>
	;===>
	For SHW_ETE_Object.EdgeToEdge = Each EdgeToEdge
		;===>
		; Cerchiamoci i vertici faccia vista verso la luce
		Surfaces = SHW_ETE_Object\Surfaces
		For aSurf = 0 To SHW_ETE_Object\cntSurface
			;===>
			If Surfaces=Null Then Goto ErrorSurf
			surf = Surfaces\IdSurface
			dwNumFaces = Surfaces\cntTriangle 
			;===>
			For v=0 To dwNumFaces
				;===>
				IdTriang = Surfaces\IdTriangle[v]
				IdCLT = TriangleClone(v)
				CloneListTriangle( IdCLT,IdTriang )
				IdA = IdCLT\a
				IdB = IdCLT\b
				IdC = IdCLT\c
				IdN = IdCLT\Normal
				;===>
				;associamo le trasformazioni ai vertici
				TFormPoint IdA\x, IdA\y , IdA\z, SHW_ETE_Object\IdModel, 0
				IdA\x = TFormedX() : IdA\y = TFormedY() : IdA\z = TFormedZ()
				;===> 
				TFormPoint IdB\x, IdB\y , IdB\z, SHW_ETE_Object\IdModel, 0
				IdB\x = TFormedX() : IdB\y = TFormedY() : IdB\z = TFormedZ() 
				;===> 
				TFormPoint IdC\x, IdC\y , IdC\z, SHW_ETE_Object\IdModel, 0
				IdC\x = TFormedX() : IdC\y = TFormedY() : IdC\z = TFormedZ() 
				;===>
				TFormNormal  IdN\x, IdN\y , IdN\z, SHW_ETE_Object\IdModel, 0
				Norm\x = TFormedX() : Norm\y = TFormedY() : Norm\z = TFormedZ()
				;Stop
				V_3Mid(MidPoint, IdA, IdB, IdC) 
				V_3Dec(NormLight, MidPoint, sh_light)
				V_3Normalize( NormLight, NormLight )
				Dot# = V_3Dot( Norm, NormLight ) 
				;===>
				; Marchiamo i vertici non rivolti verso la luce
				If Dot#=>0.0 Then
					;===>
					CNTFront=CNTFront+1
					;===>
				Else
					;===>
					IdCLT\Triangle  = -1
					CNTBack=CNTBack+1
					;===>
				EndIf
				;===> 
			Next
			;===>
			; Ora creiamo il volume
			For v=0 To dwNumFaces
				;===>
				IdCLT = TriangleClone(v)
				;===>
				; Saltiamo il triangolo se  a -1
				If IdCLT\Triangle<0 Then Goto continue
				;===>

				If IdCLT\ATriangle>=0 Then check1 = TriangleClone(IdCLT\ATriangle)\Triangle Else check1 = -1
				If IdCLT\BTriangle>=0 Then check2 = TriangleClone(IdCLT\BTriangle)\Triangle Else check2 = -1
				If IdCLT\CTriangle>=0 Then check3 = TriangleClone(IdCLT\CTriangle)\Triangle Else check3 = -1
				;===>
				If check1>-1 And check2>-1 And check3>-1  Then Goto continue
				;===>
				;Stop
				IdA =  IdCLT\a
				IdB =  IdCLT\b
				IdC =  IdCLT\c
				;===>
				;Edge A
				If check1<0 Then
					;===>
					V_3Dec( RayA, IdA, sh_light ) 
					V_3Normalize(RayA, RayA ) 
					V_3Mul(RayA, RayA, sh_lenght )
					V_3Inc( RayA,RayA, IdA )
					;===>
					V_3Dec( RayB, IdB,sh_light ) 
					V_3Normalize( RayB, RayB ) 
					V_3Mul( RayB, RayB, sh_lenght )
					V_3Inc( RayB, RayB, IdB ) 
					;===>
					va = AddVertex(SurfaceFront,  IdA\x,		IdA\y, 			IdA\z ); 
					vb = AddVertex(SurfaceFront,  RayA\x,	RayA\y,		RayA\z ); 
					vc = AddVertex(SurfaceFront,  RayB\x,	RayB\y,	RayB\z ); 
					vd = AddVertex(SurfaceFront,  IdB\x,		IdB\y, 			IdB\z ); 
					;===>
					AddTriangle(SurfaceFront, va, vb, vc); faccia 1/3 a 
					AddTriangle(SurfaceFront, va, vc, vd); faccia 1/3 b
					;===>
					Line3DAX(cntLine3D) = IdA\x : Line3DAY(cntLine3D) = IdA\y : Line3DAZ(cntLine3D) = IdA\z
					Line3DBX(cntLine3D) = IdB\x : Line3DBY(cntLine3D) = IdB\y : Line3DBZ(cntLine3D) = IdB\z
					cntLine3D=cntLine3D+1
					;===>
				EndIf
				;===>
				;Edge B
				If check2<0 Then
					;===>
					V_3Dec( RayB, IdB,sh_light ) 
					V_3Normalize( RayB, RayB ) 
					V_3Mul( RayB, RayB, sh_lenght )
					V_3Inc( RayB, RayB, IdB ) 
					;===>
					V_3Dec( RayC, IdC, sh_light ) 
					V_3Normalize(RayC, RayC ) 
					V_3Mul(RayC, RayC, sh_lenght )
					V_3Inc( RayC,RayC, IdC )
					;===>
					;Stop
					va = AddVertex(SurfaceFront,  IdB\x, 			IdB\y, 			IdB\z ); 
					vb = AddVertex(SurfaceFront,  RayB\x,	RayB\y,	RayB\z ); 
					vc = AddVertex(SurfaceFront,  RayC\x,	RayC\y,	RayC\z ); 
					vd = AddVertex(SurfaceFront,  IdC\x, 			IdC\y, 			IdC\z ); 
					;===>
					AddTriangle(SurfaceFront, va, vb, vc); faccia 1/3 a 
					AddTriangle(SurfaceFront, va, vc, vd); faccia 1/3 b
					;===>
					Line3DAX(cntLine3D) = IdB\x : Line3DAY(cntLine3D) = IdB\y : Line3DAZ(cntLine3D) = IdB\z
					Line3DBX(cntLine3D) = IdC\x : Line3DBY(cntLine3D) = IdC\y : Line3DBZ(cntLine3D) = IdC\z
					cntLine3D=cntLine3D+1
					;===>
				EndIf 
				;===>
				;Edge C
				If check3<0 Then
					;===>
					V_3Dec( RayA, IdA, sh_light ) 
					V_3Normalize(RayA, RayA ) 
					V_3Mul(RayA, RayA, sh_lenght )
					V_3Inc( RayA,RayA, IdA )
					;===>
					;===>
					V_3Dec( RayC, IdC, sh_light ) 
					V_3Normalize(RayC, RayC ) 
					V_3Mul(RayC, RayC, sh_lenght )
					V_3Inc( RayC,RayC, IdC )
					;===>
					;Stop
					va = AddVertex(SurfaceFront,  IdC\x, 			IdC\y, 			IdC\z ); 
					vb = AddVertex(SurfaceFront,  RayC\x,	RayC\y,	RayC\z ); 
					vc = AddVertex(SurfaceFront,  RayA\x,		RayA\y,		RayA\z ); 
					vd = AddVertex(SurfaceFront,  IdA\x, 			IdA\y, 			IdA\z ); 
					;===>
					AddTriangle(SurfaceFront, va, vb, vc); faccia 1/3 a 
					AddTriangle(SurfaceFront, va, vc, vd); faccia 1/3 b
					;===>
					Line3DAX(cntLine3D) = IdC\x : Line3DAY(cntLine3D) = IdC\y : Line3DAZ(cntLine3D) = IdC\z
					Line3DBX(cntLine3D) = IdA\x : Line3DBY(cntLine3D) = IdA\y : Line3DBZ(cntLine3D) = IdA\z
					cntLine3D=cntLine3D+1
					;===>
				EndIf 
				;===>
				.continue
				;===>
			Next 
			;===>
			Surfaces = After Surfaces
			.ErrorSurf
			;===>
		Next
		;===>
	Next
	;===> 
	Delete MidPoint
	Delete NormLight
	Delete Norm
	Delete RayA
	Delete RayB
	Delete RayC
	;===>
	t1=MilliSecs()
	t2=t1-t0
	Result$=Result$+"==> Facce Front : "+CNTFront+"  Facce Back : "+CNTBack + " Tim-Vert: " + t2
	;===> 
	Return Result$
	;===> 
End Function 
;=======================
;
Function SHWLine3D()
	;===>
	Color 255,0,0
	;===>
	For a=0 To cntLine3D-1
		Line3D( Line3DAX(a), Line3DAY(a), Line3DAZ(a), Line3DBX(a), Line3DBY(a), Line3DBZ(a))
	Next
	cntLine3D=0
	;===>
	Color 255,255,255
	;===>
End Function
;=======================
; Creazione immagine ombra
; Fast2 ?
Function ShadowVolumeSimulateStenciHardware1$(ShowVol)
	EntityColor SHWSpriteFront, 10, 10, 10
	EntityAlpha SHWSpriteFront, 0.3
	;===>
	SetBuffer BackBuffer()
	;======================================================================
	;PASS 1
	;===>
	;Render object modal standard
	;===>
	HideEntity SHWSpriteFront
	;colour buffer OFF
	SetRenderState(Direct3DDevice7, D3DRS_CULLMODE, D3DCULL_CCW)
	SetRenderState( Direct3DDevice7, D3DRS_ALPHABLENDENABLE, True );
	SetRenderState( Direct3DDevice7, D3DRS_SRCBLEND, D3DBLEND_ONE );
	SetRenderState( Direct3DDevice7, D3DRS_DESTBLEND, D3DBLEND_ONE );
	;lighting ON
	SetRenderState( Direct3DDevice7, D3DRS_AMBIENT, AMB_LIGHT );
	SetRenderState( Direct3DDevice7, D3DRS_LIGHTING, True );
	;depth buffer ON (Write+test)
	SetRenderState( Direct3DDevice7, D3DRS_ZENABLE, True );
	SetRenderState( Direct3DDevice7, D3DRS_ZWRITEENABLE, True );
	;stencil buffer OFF
	SetRenderState( Direct3DDevice7, D3DRS_STENCILENABLE, False );
	DeviceClear(Direct3DDevice7, 7, $00008080, 1, 0)
	CameraClsMode Camera, True, True
	;===>
	If ShowVol Then
		ShowEntity MeshFront
		EntityColor MeshFront, 255, 0,0
		EntityFX MeshFront,1+16
	Else
		HideEntity MeshFront
	EndIf
	;===>
	ShowEntity scena
	;===>
	RenderWorld
	tris=TrisRendered()
	Result$=Result$ + " Tris Render: "+TrisRendered()
	;===>
	EntityColor MeshFront,10,0,0
	EntityFX MeshFront,1
	;===>
	;======================================================================
	;PASS 2
	;===>
	CameraClsMode Camera, False, False
	HideEntity scena
	ShowEntity MeshFront
	SetRenderState(Direct3DDevice7, D3DRS_STENCILENABLE, True)
	SetRenderState(Direct3DDevice7, D3DRS_STENCILFUNC, D3DCMP_ALWAYS)
	SetRenderState(Direct3DDevice7, D3DRS_STENCILREF, 1)
	SetRenderState(Direct3DDevice7, D3DRS_SRCBLEND, D3DBLEND_ZERO)
	SetRenderState(Direct3DDevice7, D3DRS_DESTBLEND, D3DBLEND_ONE)
	;===>
	SetRenderState(Direct3DDevice7, D3DRS_CULLMODE, D3DCULL_CW)
	SetRenderState(Direct3DDevice7, D3DRS_STENCILPASS, D3DSTENCILOP_INCR)
	RenderWorld
	tris=tris+TrisRendered()
	;===>
	SetRenderState(Direct3DDevice7, D3DRS_STENCILPASS, D3DSTENCILOP_DECR)
	SetRenderState(Direct3DDevice7, D3DRS_CULLMODE, D3DCULL_CCW)
	RenderWorld
	tris=tris+TrisRendered()
	;===>
	HideEntity MeshFront
	SetRenderState(Direct3DDevice7, D3DRS_STENCILFUNC, D3DCMP_LESSEQUAL)
	SetRenderState(Direct3DDevice7, D3DRS_SRCBLEND, D3DBLEND_ONE )
	SetRenderState(Direct3DDevice7, D3DRS_DESTBLEND, D3DBLEND_ONE )
	SetRenderState(Direct3DDevice7, D3DRS_STENCILENABLE, True)
	SetRenderState(Direct3DDevice7, D3DRS_ALPHABLENDENABLE, True)
	ShowEntity SHWSpriteFront
	;===>
	RenderWorld
	tris=tris+TrisRendered()
	;===>
	SetRenderState(Direct3DDevice7, D3DRS_STENCILENABLE, False)
	SetRenderState(Direct3DDevice7, D3DRS_ALPHABLENDENABLE, True)
	HideEntity SHWSpriteFront
	Return (Result$ +" Tris All: "+tris)

End Function

