;======================================= 
;--------------------------------------- 
; 
;   Name file: Common_type 
; 
;   Programmatore: 
;      Caldarulo Vincenzo (Eye & Light) 
;   Descrizione: 
;      Gestione simil classe 
; 
;--------------------------------------- 
;======================================= 
; 
;Include "KeyConstants.bb" 
;======================================= 

;---------------------------------------
; Variabili Generiche 
;--------------------------------------- 
;======================================= 
Global LimitFps = 0; 
Global frameTime = 0; 
;======================================= 
;--------------------------------------- 
; Tabella seno e coseno 
;--------------------------------------- 
;======================================= 
Const PrecTabCos = 32 
Const MaxAngle = 450 
Const  MaxTabSinCos = (MaxAngle)*PrecTabCos; 
Global TabCos#[MaxTabSinCos]; 
For a=0 To MaxAngle-1 
   For b=0 To PrecTabCos-1 
     Arr# = (a Shl 5)+b 
     Ang# = Float(a)+((1.0/32.0)*Float(b)) 
     TabCos[Arr] = Cos(Ang); 
   Next 
Next 
;======================================= 
;--------------------------------------- 
; Variabile di return 
;--------------------------------------- 
;======================================= 
Global ReturnVal# = 0; 
Global ReturnP3D.Point3D = New Point3D;
ReturnP3D\x = 0
ReturnP3D\y = 0
ReturnP3D\z = 0
;=======================================
;--------------------------------------- 
; Tipi di luce 
;--------------------------------------- 
;======================================= 
Const LightDirect = 0 
Const LightPoint   = 1 
Const LightSpot   = 2 
;======================================= 
;--------------------------------------- 
; Variabili Gestione Statisteche 
;--------------------------------------- 
;======================================= 
Global FPS_TFrame# = 1 
Global FPS_TTime# = MilliSecs() 
Global FPS_TOldTime# = 1 
Global FPS_TNewTime# = 1 
Global FPS_TMidleTime# 
Global FPS_IncTime# = 0 
;======================================= 
;--------------------------------------- 
; Variabili Gestione Camera 
;--------------------------------------- 
;======================================= 
Global  Camera; 
Global  CamPX#,CamPY#,CamPZ#; 
Global  CamRX#,CamRY#,CamRZ#;

;======================================= 
;--------------------------------------- 
; Variabili Gestione Obj Fake 
;--------------------------------------- 
;======================================= 
Global  FkPX#,FkPY#,FkPZ#; 
Global  FkRX#,FkRY#,FkRZ#; 
;======================================= 
;--------------------------------------- 
; Variabili globali per le 
; funzioni contenute qu 
;--------------------------------------- 
;======================================= 
;======================================= 
;--------------------------------------- 
; Variabili globali per Video 
;--------------------------------------- 
;======================================= 
Global  VisoreOpen = False; 
;======================================= 
;--------------------------------------- 
; Variabili globali per Motion Effect 
;--------------------------------------- 
;======================================= 
Const   SizeMotion# = 1 
Const   SizeTMotion# = 256 
Global  MMotion01 
Global  SMotion01 
Global  TMotion01 
;======================================= 
;--------------------------------------- 
; Variabili Gestione Statistiche 
;--------------------------------------- 
;======================================= 
Global Vector = CreateSphere(5);LoadMesh("vector.3DS")
ScaleEntity Vector,0.1,0.1,0.1
EntityColor Vector,255,0,255
;======================================= 
;--------------------------------------- 
; Punto 2D 
;--------------------------------------- 
;======================================= 
Type Point2D 
   Field x# 
   Field y# 
End Type 
;======================================= 
;--------------------------------------- 
; Punto 3D 
;--------------------------------------- 
;======================================= 
Type Point3D 
   Field x# 
   Field y# 
   Field z# 
End Type 
;================================ 
;-------------------------- 
; Rotazione Asse X 
;-------------------------- 
;================================ 
Function DrawVector( P.Point3D, R.Point3D, parent=0) 
  EntityOrder Vector,-1 
   If (parent) 
     ;------ 
     EntityParent   Vector, parent 
     PositionEntity Vector, 0, 0, 0; 
     RotateEntity   Vector, 180, 180, 0; 
     ;------ 
   Else 
     ;------ 
     PositionEntity Vector, P\x, P\y, P\z; 
     RotateEntity   Vector, R\x, R\y, R\z; 
     ;------ 
   End If 
End Function 
;=========================================================================== 
;--------------------------------------------------------------------------- 
; Funzioni di rotazione 3D 
;--------------------------------------- 
;======================================= 
; Assi di rotazione sono composti cos Rx-Rz-Ry per il campionamento da oggetto 
;================================ 
;-------------------------- 
; Rotazione Asse X 
;-------------------------- 
;================================ 
Function RotX.Point3D( Rot#, P.Point3D) 
   ;----> 
  dst.Point3D = New Point3D 
   ;----> 
   c# = Cos(Rot) : s# = Sin(Rot); 
   ;----> 
   ;Rotazione Asse X 
   dst\x# = P\x; 
   dst\y# = (P\y * c)-(P\z * s); 
   dst\z# = (P\z * c)+(P\y * s); 
   ;----> 
   Return dst 
   ;----> 
End Function 

Function FRotX.Point3D( Rot#, P.Point3D) 
   ;----> 
  dst.Point3D = New Point3D 
   ;----> 
   c# = TbCos(Rot) : s# = TbSin(Rot); 
   ;----> 
   ;Rotazione Asse X 
   dst\x# = P\x; 
   dst\y# = (P\y * c)-(P\z * s); 
   dst\z# = (P\z * c)+(P\y * s); 
   ;----> 
   Return dst 
   ;----> 
End Function 
; 
;================================ 
;-------------------------- 
; Rotazione Asse Y 
;-------------------------- 
;================================ 
; 
Function RotY.Point3D( Rot#, P.Point3D) 
   ;----> 
  dst.Point3D = New Point3D 
   ;----> 
   c# = Cos(Rot) : s# = Sin(Rot); 
   ;------ 
   ;Rotazione Asse X 
   dst\x# = (P\x * c)+(P\z * s); 
   dst\y# = P\y; 
   dst\z# = (P\z * c)-(P\x * s); 
   ;----> 
   Return dst 
   ;----> 
End Function 

Function FRotY.Point3D( Rot#, P.Point3D) 
   ;----> 
  dst.Point3D = New Point3D 
   ;----> 
   c# = TbCos(Rot) : s# = TbSin(Rot); 
   ;------ 
   ;Rotazione Asse X 
   dst\x# = (P\x * c)+(P\z * s); 
   dst\y# = P\y; 
   dst\z# = (P\z * c)-(P\x * s); 
   ;----> 
   Return dst 
   ;----> 
End Function 
; 
;================================ 
;-------------------------- 
; Rotazione Asse Z 
;-------------------------- 
;================================ 
; 
Function RotZ.Point3D( Rot#, P.Point3D) 
   ;----> 
  dst.Point3D = New Point3D 
   ;----> 
   c# = Cos(Rot) : s# = Sin(Rot); 
   ;------ 
   ;Rotazione Asse X 
   dst\x# = (P\x * c)-(P\y * s); 
   dst\y# = (P\y * c)+(P\x * s); 
   dst\z# = P\z; 
   ;----> 
   Return dst 
   ;----> 
End Function 

Function FRotZ.Point3D( Rot#, P.Point3D) 
   ;----> 
  dst.Point3D = New Point3D 
   ;----> 
   ;------ 
   c# = TbCos(Rot) : s# = TbSin(Rot); 
   ;------ 
   ;Rotazione Asse X 
   dst\x# = (P\x * c)-(P\y * s); 
   dst\y# = (P\y * c)+(P\x * s); 
   dst\z# = P\z; 
   ;----> 
   Return dst 
   ;----> 
End Function 
;=========================================================================== 
;--------------------------------------------------------------------------- 
; Funzioni Matematiche 
;--------------------------------------- 
;======================================= 

Function Over#(val#) 
  Return 1.0/val; 
End Function 

Function V_3Inc( Rtn.Point3D, val1.Point3D, val2.Point3D) 
	;----> 
	Rtn\x = val1\x + val2\x; 
	Rtn\y = val1\y + val2\y; 
	Rtn\z = val1\z + val2\z; 
	;----> 
End Function 

Function V_3Dec( Rtn.Point3D, val1.Point3D, val2.Point3D) 
	;----> 
	Rtn\x = val1\x - val2\x; 
	Rtn\y = val1\y - val2\y; 
	Rtn\z = val1\z - val2\z;
	;----> 
End Function 

Function V_3Mul( Rtn.Point3D, val1.Point3D, val2.Point3D) 
	;----> 
	Rtn\x = val1\x * val2\x; 
	Rtn\y = val1\y * val2\y; 
	Rtn\z = val1\z * val2\z; 
	;----> 
End Function 

Function V_3Div( Rtn.Point3D, val1.Point3D, val2.Point3D) 
	;----> 
	Rtn\x = val1\x / val2\x; 
	Rtn\y = val1\y / val2\y; 
	Rtn\z = val1\z / val2\z; 
	;----> 
End Function 

Function V_3Dist#( val1.Point3D, val2.Point3D) 
	;----> 
	V_3Dec( ReturnP3D, val1, val2) 
	Val# = Sqr( (ReturnP3D\x^2)+(ReturnP3D\y^2)+(ReturnP3D\z^2) ) 
	;----> 
	Return Val# 
	;----> 
End Function 
;=========================================================================== 
;--------------------------------------------------------------------------- 
; Funzioni Vettore 3D 
;--------------------------------------- 
;======================================= 
;================================ 
;-------------------------- 
; Normalizzazione 
;-------------------------- 
;================================ 
; 
Function V_3Normalize( Rtn.Point3D, val.Point3D ) 
   ;===>
   d# = Sqr( (val\x*val\x) + (val\y*val\y) + (val\z*val\z) ) 
	 ;===>
   do# = Over(d#)
   ;===>
   Rtn\x = val\x*do; 
   Rtn\y = val\y*do; 
   Rtn\z = val\z*do;
   ;===>
End Function 
;================================ 
;-------------------------- 
; Prodotto Vettoriale Cross (Prodotto vettoriale) 
;-------------------------- 
;================================ 
; 
Function V_3Cross( Rtn.Point3D, A.Point3D, B.Point3D ) 
   ;----> 
   ; Compute their cross product. 
   Rtn\x# = A\y#*B\z# - A\z#*B\y# 
   Rtn\y# = A\z#*B\x# - A\x#*B\z# 
   Rtn\z# = A\x#*B\y# - A\y#*B\x# 
   ;----> 
End Function 
;================================ 
;-------------------------- 
; Prodotto Vettoriale Dot (Prodotto scalare) 
;-------------------------- 
;================================ 
; 
Function V_3Dot#( A.Point3D, B.Point3D ) 
   ;----> 
   Return ((A\x#*B\x#)+(A\y#*B\y#)+(A\z#*B\z#)); 
   ;----> 
End Function 
;================================ 
;-------------------------- 
; Punto medio il cento della normale 
;-------------------------- 
;================================ 
; 
Function V_3Mid( Rtn.Point3D, A.Point3D, B.Point3D, C.Point3D) 
   ;===> 
   Rtn\x=(A\x#+B\x#+C\x)/3 
   Rtn\y=(A\y#+B\y#+C\y)/3 
   Rtn\z=(A\z#+B\z#+C\z)/3 
   ;===> 
End Function 
;================================ 
;-------------------------- 
; Copia contenuto
;-------------------------- 
;================================ 
; 
Function V_3Copy(a.Point3D,b.Point3D) 
   ;===> 
   a\x#=b\x# 
   a\y#=b\y#
   a\z#=b\z#
   ;===> 
End Function 
;================================ 
;-------------------------- 
; Calcolo della normale 
;-------------------------- 
;================================ 
; 
Function CalcNormal( Rtn.Point3D, A.Point3D, B.Point3D, C.Point3D ) 
   ;---->
	 Local K1.Point3D = New Point3D
	 Local K2.Point3D = New Point3D
	 V_3Dec(K1, C, B)
	 V_3Dec(K2, B, A)
	 V_3Cross( Rtn, K1, K2 )
   ;---->
	 Delete K1
	 Delete K2
   ;----> 
End Function 

;--------------------------------------------------------------------------- 
;=========================================================================== 
;--------------------------------------------------------------------------- 
; Funzioni di statistica 
;--------------------------------------- 
Function FPS$() 
	;===>	
	; Calcolo FPS
	FPS_TNewTime# = MilliSecs()
	FPS_TFrame# = FPS_TFrame + 1 
	FPS_TMidleTime# = (FPS_TNewTime-FPS_TTime)/FPS_TFrame 
	FPS#=1000.0/FPS_TMidleTime
	FPS_IncTime#= 1000/(FPS_TNewTime-FPS_TOldTime) 
	;===>	
	;Text 10,0,"FPS Medio: "+FPS+" // Time Medio: "+FPS_TMidleTime+" // FPS: "+FPS_IncTime+" // Time: "+FPS_IncTime; 
	a$="FPS Medio: "+FPS+" // Time Medio: "+FPS_TMidleTime+" // FPS: "+FPS_IncTime+" // Time: "+FPS_IncTime; 
	FPS_TOldTime = FPS_TNewTime
	Return a$
	;===>	
End Function 
;--------------------------------------------------------------------------- 
; Funzioni di gestione Frame-Rate 
;--------------------------------------- 
Function FPS_Limit(MaxFPS) 
  ; Setup the frame limiting code 
  LimitFps = 1000 / (MaxFPS+1) 
  frameTime = MilliSecs() 
End Function 
;--------------------------------------------------------------------------- 
; Funzioni attesa per sink 
;--------------------------------------- 
Function FPS_Wait() 
  ;================================ 
  ;----------------------------- 
  ;If (KeyDown(Key_F5)) Stop 
  ;----------------------------- 
  ;================================ 
  ; Here we limit the frames 
  Repeat 
    frameElapsed = MilliSecs() - frameTime 
      ;Text 10, 4*15,"ms "+frameElapsed 
  Until frameElapsed>0 
  frametime = MilliSecs()+limitFPS 
End Function 
;--------------------------------------------------------------------------- 
;=========================================================================== 
;--------------------------------------------------------------------------- 
; Funzioni di Gestione camera 
;--------------------------------------- 
Function CameraView( MStep#=1, RStep#=1, NewCam=False) 
  If (NewCam) 
    ; Saltiamo per intero la vecchia camera 
    Procedure_Freelook(1.05,0.2) 
   Else 
    VelStep# = MStep; 
    RotStep# = RStep; 
    Ctrl  = (KeyDown(Key_LeftControl)) Or (KeyDown(Key_RightControl)) 
    Shift = (KeyDown(Key_LeftShift))   Or (KeyDown(Key_RightShift)) 
    If (Ctrl) 
        ;Key Up 
       If KeyDown(Key_ArrowPad_Up) Then 
           MoveEntity Camera, 0, VelStep , 0 
        End If 
        ;Key Down 
        If KeyDown(Key_ArrowPad_Down) Then 
           MoveEntity Camera, 0, -VelStep , 0 
        End If 
        ;Key Left 
       If KeyDown(Key_ArrowPad_Left) Then 
           MoveEntity Camera, RotStep, 0, 0 
        End If 
        ;Key Right 
        If KeyDown(Key_ArrowPad_Right) Then 
           MoveEntity Camera, -RotStep, 0, 0 
        End If 
    Else 
        ;Key Up 
        If KeyDown(Key_ArrowPad_Up) Then 
           MoveEntity Camera, 0, 0, VelStep 
        End If 
        ;Key Down 
        If KeyDown(Key_ArrowPad_Down) Then 
           MoveEntity Camera, 0, 0, -VelStep 
        End If 
        ;Key Left 
       If KeyDown(Key_ArrowPad_Left) Then 
           TurnEntity Camera, 0, RotStep, 0 
        End If 
        ;Key Right 
        If KeyDown(Key_ArrowPad_Right) Then 
         TurnEntity Camera, 0, -RotStep, 0 
        End If 
    End If 
  End If 
   CamPX = EntityX(Camera); 
   CamPY = EntityY(Camera); 
   CamPZ = EntityZ(Camera); 
   CamRX = EntityPitch(Camera); 
   CamRY = EntityYaw(Camera); 
   CamRZ = EntityRoll(Camera); 


End Function 

Function Procedure_Freelook(Velocity#,Speed#)
	Local Camera_RX#,Camera_RY#

   Mouse_X_Speed#=MouseXSpeed()*0.5 
   Mouse_Y_Speed#=MouseYSpeed()*0.5 

   MoveMouse GraphicsWidth()/2,GraphicsHeight()/2 
   Camera_Pitch# = Camera_Pitch# + Mouse_Y_Speed 
   Camera_Yaw# = Camera_Yaw# - Mouse_X_Speed 

   If Camera_Pitch < -89 Then Camera_Pitch = -89 
   If Camera_Pitch > 89 Then Camera_Pitch = 89 

   RotateEntity camera,Camera_Pitch,Camera_Yaw,0 

   If KeyDown(Key_ArrowPad_Left) Camera_VelX=Camera_VelX-Speed# ElseIf KeyDown(Key_ArrowPad_Right) Camera_VelX=Camera_VelX+Speed# 
   If KeyDown(Key_ArrowPad_Down) Camera_VelZ=Camera_VelZ-Speed# ElseIf KeyDown(Key_ArrowPad_Up) Camera_VelZ=Camera_VelZ+Speed# 

   Camera_VelX = Camera_VelX/Velocity# 
   Camera_VelZ = Camera_VelZ/Velocity# 
   MoveEntity camera,Camera_VelX,0,Camera_VelZ 
End Function 

;--------------------------------------------------------------------------- 
;=========================================================================== 
;--------------------------------------------------------------------------- 
; Funzioni di Clamp 
;--------------------------------------- 
Function Clamp#(val#,min#,max#) 
	If (val<min) 
		Return min# 
	ElseIf (val>max) 
		Return max# 
	Else 
		Return val# 
	EndIf 
End Function 

Function ClampUP#(val#,max#) 
	If (val>max) 
		Return max# 
	Else 
		Return val# 
	End If 
End Function 

Function ClampDOWN#(val#,min#) 
	If (val<min) 
		Return min# 
	Else 
		Return val# 
	End If 
End Function 
;--------------------------------------------------------------------------- 
;=========================================================================== 
;-------------------------- 
; 
;-------------------------- 
;================================ 
Function RotInterAcc( DstRX#, DstRY#, DstRZ#, MinAngle#=5, Acc#=16, Apr#=0.1) 
  St1# = (DstRX-CamRX) 
  St2# = (DstRY-CamRY) 
  St3# = (DstRZ-CamRZ) 
  ; 
  CamRX = CamRX + (St1/Acc) 
  CamRY = CamRY + (St2/Acc) 
  CamRZ = CamRZ + (St3/Acc) 
  ; 
  If ((Abs(St1)<MinAngle) And (Abs(St2)<MinAngle) And (Abs(St3)<MinAngle)) 
    Return True 
  End If 
  ; 
  If ((Abs(St1)<Apr) And (Abs(St2)<Apr) And (Abs(St3)<Apr)) 
    CamRX = DstRX 
    CamRY = DstRY 
    CamRZ = DstRZ 
    Return True 
  EndIf 
  Return False 
End Function 
;================================ 
;-------------------------- 
; 
;-------------------------- 
;================================ 
Function PosInterAcc( DstPX#, DstPY#, DstPZ#, Acc=16, Apr#=0.1) 
  St1# = (DstPX-CamPX) 
  St2# = (DstPY-CamPY) 
  St3# = (DstPZ-CamPZ) 
   ; 
  CamPX = CamPX + (St1/Acc) 
  CamPY = CamPY + (St2/Acc) 
  CamPZ = CamPZ + (St3/Acc) 
   ; 
  If ((Abs(St1)<Apr) And (Abs(St2)<Apr) And (Abs(St3)<Apr)) 
    CamPX = DstPX 
    CamPY = DstPY 
    CamPZ = DstPZ 
    Return True 
  EndIf 
  Return False 
End Function 
;--------------------------------------------------------------------------- 
;=========================================================================== 
;-------------------------- 
; 
;-------------------------- 
;================================ 
Function GetCoordObj(Obj) 
  FkPX = EntityX(Obj) 
  FkPY = EntityY(Obj) 
  FkPZ = EntityZ(Obj) 
  ; 
  FkRX = EntityPitch(Obj) 
  FkRY = EntityYaw(Obj) 
  FkRZ = EntityRoll(Obj) 
End Function 
;--------------------------------------------------------------------------- 
;=========================================================================== 
;-------------------------- 
; 
;-------------------------- 
;================================ 
Function PlayVideo(Name$, Video, Texture=0,CRect=0) 
     If (VisoreOpen=False) 
      Video = OpenMovie(Name); 
      VisoreOpen=True 
      Else 
        ;  Se c' la texture fai il draw in texture altrimenti Nisba 
        If (Texture) 
          If (CRect) 
          DrawMovie Video,0,0,256,256; 
           CopyRect 0,0,TextureWidth(Texture),TextureHeight(Texture),0,0,BackBuffer(),TextureBuffer(Texture) 
          Else 
             SetBuffer TextureBuffer(Texture) 
          DrawMovie Video,0,0,256,256; 
           End If 
        Else 
        DrawMovie Video,140,65; 
        End If 

      If ((Not MoviePlaying(Video)) Or (Enter)) 
        CloseMovie(Video); 
        VisoreOpen = False; 
        Video = 0 
            ;return Video 
      End If 
      End If 
     ;if (Texture) SetBuffer BackBuffer 

   Return Video 
End Function 
;--------------------------------------------------------------------------- 
;=========================================================================== 
;-------------------------- 
; Motion Effect 
;-------------------------- 
;================================ 
;ValoriUtili per i Fat da inserire 
; Fat = 0.96 (Aggiunge spessore all'immagine) 
Function InitMotionBlur( BlendParam=3, Tipe=0, Format=0, Fat#=0.96) 
   Larg# = GraphicsWidth() 
   Alt#  = GraphicsHeight() 
   If(Larg>Alt) 
    TMotion01 = CreateTexture( Larg, Larg, 256);512) 
  Else 
    TMotion01 = CreateTexture( Alt, Alt, 256);512) 
  End If 
   ; Definiamo la tipologia di Distorsione 
   Select (Format) 
     Case 0 ; 
       DistorX# = 1.0 
       DistorY# = 1.0 
     Case 1 ; 
       DistorX# = 1.0/Fat 
       DistorY# = Fat/1.0 
     Case 2 ; 
       DistorX# = Fat/1.0 
       DistorY# = 1.0/Fat 
     Case 3 ; 
       DistorX# = 1.0/Fat 
       DistorY# = 1.0/Fat 
     Default ; 
       DistorX# = Fat/1.0 
       DistorY# = Fat/1.0 
   End Select 
   ;------ 
   AsRatio# = Alt/Larg 
   TexW = TextureWidth(TMotion01) 
   TexH = TextureHeight(TMotion01) 
   TexU# = (Larg/TexW) 
   TexV# = (Alt/TexH) 
   ;------ 
   MMotion01=CreateMesh() 
   SMotion01=CreateSurface(MMotion01) 
   VX# = SizeMotion*DistorX 
   VY# = SizeMotion*AsRatio*DistorY 
   VZ# = 0; 
   ; 
   AddVertex(SMotion01, VX, VY, VZ, TexU,    0) 
   AddVertex(SMotion01,-VX, VY, VZ,    0,    0) 
   AddVertex(SMotion01,-VX,-VY, VZ,    0, TexV) 
   AddVertex(SMotion01, VX,-VY, VZ, TexU, TexV) 
   ; 
   AddTriangle(SMotion01,0,2,1) 
   AddTriangle(SMotion01,0,3,2) 
   EntityParent(MMotion01,Camera) 
   PositionEntity MMotion01,0,0,1 
   EntityTexture(MMotion01,TMotion01) 
   ; definiamo la tipologia di effetto da applicare 
   Select (Tipe) 
     Case 0 
       EntityAlpha(MMotion01,0.5) 
     Case 1 
      EntityBlend(MMotion01,BlendParam) 
     Default 
       EntityAlpha(MMotion01,0.5) 
      EntityBlend(MMotion01,BlendParam) 
   End Select 
   ;entityAlpha(MMotion01,0.75) 
   ;entityBlend(MMotion01,BlendParam) 
   ;------------ 
End Function 

Function UpdateMotionBlur(On=True) 
   If (On) 
     ShowEntity MMotion01 
    Larg# = GraphicsWidth() 
     Alt#  = GraphicsHeight() 
     Px = 0; 
     Py = 0; 
    CopyRect Px,Py,Larg,Alt,0,0,BackBuffer(),TextureBuffer(TMotion01) 
   Else 
     HideEntity MMotion01 
   End If 
End Function 
;--------------------------------------------------------------------------- 
;=========================================================================== 
;-------------------------- 
; Emboss Pixel Fast 
;-------------------------- 
;================================ 
; 
Function EmbossFast(TextureOr,Texture,Angle=0,Profondita=5) 
    
   n# = Cos(Angle)*profondita 
   m# = Sin(Angle)*profondita 
   power = 10 
    
  txtBuff1 = TextureBuffer(TextureOr) 
  txtBuff2 = TextureBuffer(Texture) 
  width = TextureWidth(TextureOr) 
  height = TextureHeight(TextureOr) 

  LockBuffer(txtBuff1) 
  LockBuffer(txtBuff2) 

  For x = 0 To width-1 
    For y = 0 To height-1 

      c1 = ReadPixelFast(x,y,txtBuff1) 
      r1 = (c1 And $ff0000) Shr 16 

      c2 = ReadPixelFast(x+n,y+m,txtBuff1) 
      r2 = (c2 And $ff0000) Shr 16 

      r = red+((r2-r1)*power) 
      If r < 0 Then r = 0 
      If r > 255 Then r = 255 

      ;c = (c1 And $000000) + (r Shl 16) + (g Shl 8) +b 
      c = (r Shl 16) + (r Shl 8) +r 

      WritePixelFast(x,y,c,txtBuff2) 

    Next 
  Next 
  UnlockBuffer(txtBuff1) 
  UnlockBuffer(txtBuff2) 
End Function 
;-------------------------- 
; Emboss Pixel 
;-------------------------- 
;================================ 
; 
Function Emboss(TextureOr,Texture,Angle=0,Profondita=5) 
    
   n# = Cos(Angle)*profondita 
   m# = Sin(Angle)*profondita 
   power = 5 
    
  txtBuff1 = TextureBuffer(TextureOr) 
  txtBuff2 = TextureBuffer(Texture) 
  width = TextureWidth(TextureOr) 
  height = TextureHeight(TextureOr) 

  LockBuffer(txtBuff1) 
  LockBuffer(txtBuff2) 

  For x = 0 To width-1 

    For y = 0 To height-1 

      c1 = ReadPixelFast(x,y,txtBuff1) 
      r1 = (c1 And $ff0000) Shr 16 
      g1 = (c1 And $ff00) Shr 8 
      b1 = (c1 And $ff) 

      c2 = ReadPixelFast(x+n,y+m,txtBuff1) 
      r2 = (c2 And $ff0000) Shr 16 
      g2 = (c2 And $ff00) Shr 8 
      b2 = (c2 And $ff) 

      r = red+((r2-r1)*power) 
      If r < 0 Then r = 0 
      If r > 255 Then r = 255 
      g = green+((g2-g1)*power) 
      If g < 0 Then g = 0 
      If g > 255 Then g = 255 
      b = blue+((b2-b1)*power) 
      If b < 0 Then b = 0 
      If b > 255 Then b = 255 

      ;c = (c1 And $000000) + (r Shl 16) + (g Shl 8) +b 
      c = (r Shl 16) + (g Shl 8) +b 

      WritePixelFast(x,y,c,txtBuff2) 

    Next 
  Next 
  UnlockBuffer(txtBuff1) 
  UnlockBuffer(txtBuff2) 
End Function 
;--------------------------------------------------------------------------- 
;=========================================================================== 
;-------------------------- 
; Get Cos 
;-------------------------- 
;================================ 
; 
Function TbCos#(Angle#) 
   If (Angle<0) 
     Angle# = 360.0-(Abs(Angle#)) 
   End If 
   vtab = Abs((Angle*PrecTabCos) Mod (360*PrecTabCos)) 
   Return TabCos[vtab] 
End Function 
;================================ 
;-------------------------- 
; Get Sin 
;-------------------------- 
;================================ 
; 
Function TbSin#(Angle#)
   If (Angle<0) 
     Angle# = 360.0-(Abs(Angle#)) 
   End If 
   vtab = Abs((Angle*PrecTabCos) Mod (360*PrecTabCos)) 
   Return TabCos[vtab+(90*PrecTabCos)] 
End Function

;================================ 
;-------------------------- 
; Gestine linee 3D
;-------------------------- 
;================================ 
Function Line3D(ax#,ay#,az#,bx#,by#,bz#)
	;===>
	CameraProject camera, ax,ay,az
	lx1=ProjectedX()
	ly1=ProjectedY()
	;===>
	CameraProject camera, bx,by,bz
	lx2=ProjectedX()
	ly2=ProjectedY()
	;===>
	Line lx1,ly1,lx2,ly2
	;===>
	If ax=bx And ay=by And az=bz Then DebugLog "linea inesistente"
	;===>
End Function 
;======================================================================= 
